﻿local addon, ns = ...
local cfg = ns.cfg
local G, F, C, L = unpack(select(2,...))
local function keiFunc()
if InkedChar.GoldInfoBar ==  false  then return end
local init = ns.init
local panel = CreateFrame("Frame", nil, UIParent)



if cfg.Gold == true then
local SILVER_AMOUNT_TEXTURE = "\124TInterface\\MoneyFrame\\UI-SilverIcon:%d:%d:1:0\124t";
local GOLD_AMOUNT_TEXTURE = "\124TInterface\\MoneyFrame\\UI-GoldIcon:%d:%d:1:0\124t";
local COPPER_AMOUNT_TEXTURE = "\124TInterface\\MoneyFrame\\UI-CopperIcon:%d:%d:1:0\124t";
local GoldIcon = format(GOLD_AMOUNT_TEXTURE)
local SilverIcon = format(SILVER_AMOUNT_TEXTURE)
local CopperIcon = format(COPPER_AMOUNT_TEXTURE)

	local Stat = CreateFrame("Frame","diminfo_Gold")
	Stat:EnableMouse(true)
	Stat:SetFrameStrata("BACKGROUND")
	Stat:SetFrameLevel(3)

	local Text  = panel:CreateFontString(nil, "OVERLAY")
	Text:SetFont(unpack(cfg.Fonts))
	Text:SetPoint(unpack(cfg.GoldPoint))

	local Profit	= 0
	local Spent		= 0
	local OldMoney	= 0

	local function formatMoney(money)
		local gold = floor(math.abs(money) / 10000)
		local silver = mod(floor(math.abs(money) / 100), 100)
		local copper = mod(floor(math.abs(money)), 100)
		if gold ~= 0 then
			return format("%s"..GoldIcon.." %s"..SilverIcon.." %s"..CopperIcon, gold, silver, copper)
		elseif silver ~= 0 then
			return format("%s"..SilverIcon.." %s"..CopperIcon, silver, copper)
		else
			return format("%s"..CopperIcon, copper)
		end
	end
	
	local function formatTextMoney(money)
	
		local gold = floor(math.abs(money) / 10000)
		local silver = mod(floor(math.abs(money) / 100), 100)
		local copper = mod(floor(math.abs(money)), 100)
		if gold ~= 0 then
			return format("%s"..GoldIcon.." %s"..SilverIcon.." %s"..CopperIcon, gold, silver, copper)
		elseif silver ~= 0 then
			return format("%s"..SilverIcon.." %s"..CopperIcon, silver, copper)
		else
			return format("%s"..CopperIcon, copper)
		end
	
	
		--return format("%.0f|cffffd700%s|r", formatMoney(OldMoney),GOLD_AMOUNT_SYMBOL)
		--return format("%.0f|cffffd700%s|r", money * 0.0001, GOLD_AMOUNT_SYMBOL)
	end

	local function FormatTooltipMoney(money)
		local gold, silver, copper = abs(money / 10000), abs(mod(money / 100, 100)), abs(mod(money, 100))
		local cash = ""
		cash = format("%d"..GoldIcon.." %d"..SilverIcon.." %d"..CopperIcon, gold, silver, copper)		
		return cash
	end	

	local function OnEvent(self, event)
		if event == "PLAYER_ENTERING_WORLD" then
			OldMoney = GetMoney()
		end
		
		local NewMoney	= GetMoney()
		local Change = NewMoney-OldMoney -- Positive if we gain money
		
		if OldMoney > NewMoney then		-- Lost Money
			Spent = Spent - Change
		else							-- Gained Moeny
			Profit = Profit + Change
		end
		
		if OldMoney == NewMoney then		-- No Change 
			Profit = 0		
			else							-- Gained Moeny
			Profit = Profit + Change			
		end
		
		Text:SetText(formatTextMoney(NewMoney))
		-- Setup Money Tooltip
		self:SetAllPoints(Text)

		local myPlayerRealm = GetRealmName();
		local myPlayerName  = UnitName("player");				
		if (diminfo.gold == nil) then diminfo.gold = {}; end
		if (diminfo.gold[myPlayerRealm]==nil) then diminfo.gold[myPlayerRealm]={}; end
		diminfo.gold[myPlayerRealm][myPlayerName] = GetMoney();
		
		Stat:SetScript("OnEnter", function()
			
				GameTooltip:SetOwner(self, "ANCHOR_BOTTOM", 0, -10)
				GameTooltip:ClearAllPoints()
				GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
				GameTooltip:ClearLines()
				GameTooltip:AddLine(CURRENCY,0,.6,1)
				
				GameTooltip:AddLine("Session",infoL["Session: "],.6,.8,1)
				GameTooltip:AddLine("")
				GameTooltip:AddLine(formatMoney(OldMoney))
				--GameTooltip:AddDoubleLine(infoL["Earned: "], formatMoney(OldMoney), 1, 1, 1, 1, 1, 1)
				GameTooltip:AddLine("Earned:")
				GameTooltip:AddLine("")
				GameTooltip:AddLine(formatMoney(Profit))				
				--GameTooltip:AddDoubleLine(infoL["Earned: "], formatMoney(Profit), 1, 1, 1, 1, 1, 1)
				GameTooltip:AddLine("")
				GameTooltip:AddLine("")
				GameTooltip:AddLine("Spent: ")
				GameTooltip:AddLine("")
				GameTooltip:AddLine(formatMoney(Spent))
				--GameTooltip:AddDoubleLine(infoL["Spent: "], formatMoney(Spent), 1, 1, 1, 1, 1, 1)
				
				GameTooltip:AddLine(" ")
				--[[
				if Profit < Spent then
					GameTooltip:AddDoubleLine(infoL["Deficit:"], formatMoney(Profit-Spent), 1, 0, 0, 1, 1, 1)
				elseif (Profit-Spent)>0 then
					GameTooltip:AddDoubleLine(infoL["Profit:"], formatMoney(Profit-Spent), 0, 1, 0, 1, 1, 1)
				end		
]]--				
				GameTooltip:AddLine(" ")
				GameTooltip:Show()
			
		end)
		Stat:SetScript("OnLeave", function() GameTooltip:Hide() end)
		
		OldMoney = NewMoney
		
	end
	Stat:SetScript("OnMouseDown", function(self,button)
		
			ToggleAllBags()

	end)
	Stat:RegisterEvent("PLAYER_LOGIN")
	Stat:RegisterEvent("PLAYER_MONEY")
	Stat:RegisterEvent("SEND_MAIL_MONEY_CHANGED")
	Stat:RegisterEvent("SEND_MAIL_COD_CHANGED")
	Stat:RegisterEvent("PLAYER_TRADE_MONEY")
	Stat:RegisterEvent("TRADE_MONEY_CHANGED")
	Stat:RegisterEvent("PLAYER_ENTERING_WORLD")
	--Stat:SetScript("OnMouseDown", function() ToggleCharacter("TokenFrame") end)
	Stat:SetScript("OnEvent", OnEvent)

end
end
G:RegisterEvent("PLAYER_LOGIN",keiFunc)