local addonName, addon = ...
addon[1] = {} -- Gloable
addon[2] = {} -- Function
addon[3] = {} -- Config
addon[4] = {} -- Locale

local G, F, C, L = unpack(addon)

local events = {}

local host = CreateFrame("Frame")
host:SetScript("OnEvent", function(_, event, ...)
	for func in pairs(events[event]) do
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			func(event, CombatLogGetCurrentEventInfo())
		else
			func(event, ...)
		end
	end
end)

function G:RegisterEvent(event, func, unit1, unit2)
	if not events[event] then
		events[event] = {}
		if unit1 then
			host:RegisterUnitEvent(event, unit1, unit2)
		else
			host:RegisterEvent(event)
		end
	end

	events[event][func] = true
end

function G:UnregisterEvent(event, func)
	local funcs = events[event]
	if funcs and funcs[func] then
		funcs[func] = nil

		if not next(funcs) then
			events[event] = nil
			host:UnregisterEvent(event)
		end
	end
end

local DefaultDB = {
	FirstUSE = true;

	
}

local eventframe = CreateFrame("Frame")
eventframe:RegisterEvent("ADDON_LOADED")
eventframe:SetScript("OnEvent",function(self,_,addon)
	--if addon ~= "InkedDB" then return end
	if not InkedDB then InkedDB = {} end
	
		for i, j in pairs(DefaultDB) do
		if type(j) == "table" then
			if InkedDB[i] == nil then InkedDB[i] = {} end
			for k, v in pairs(j) do
				if InkedDB[i][k] == nil then
					InkedDB[i][k] = v
				end
			end
		else
			if InkedDB[i] == nil then InkedDB[i] = j end
		end
	end
	self:UnregisterAllEvents()

end)
local function TestFunc()
if InkedDB["keivamp"] ==  true  then print("Inked") end
end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)